<template>
    <!-- V3 .env-->
    <!-- Overlay หน้าแสดงข้อมูลตามรายชื่อที่เลือก -->
    <v-overlay v-model="overlay" class="align-center justify-center">
        <v-card class="lg" width="400">
            <v-img class="lg" :width="400" aspect-ratio="1/1" cover :src=tempData.avatar></v-img>

            <v-divider :thickness="6" class="border-opacity-100 ma-2"></v-divider>

            <v-card-title>
                {{ tempData.fname }} {{ tempData.lname }}
            </v-card-title>

            <v-card-text>
                Email : {{ tempData.username }}
            </v-card-text>
        </v-card>
    </v-overlay>

    <!-- OverlayInsert เพิ่อเพิ่มข้อมูลลงตาราง -->
    <v-overlay v-model="overlayInsert" class="align-center justify-center">
        <v-card class="lg" :width="300">
            <v-card-title>Insert</v-card-title>
            <v-card-text>
                <v-form v-model="formRules">
                <v-text-field v-model="fname" label="First Name"></v-text-field>
                <v-text-field v-model="lname" label="Last Name"></v-text-field>
                <v-text-field v-model="username" label="Username"></v-text-field>
                <v-text-field v-model="password" :rules="passwordRules" label="Password" type="password"></v-text-field>
                <v-text-field v-model="email" label="E-mail"></v-text-field>
                <v-text-field v-model="avatar" label="Avatar"></v-text-field>
                </v-form>
            </v-card-text>
            <v-card-actions class="justify-end">
                <v-btn :disabled="!formRules" @click="addUser">Confirm</v-btn>
                <v-btn @click="overlayInsert = !overlayInsert">Cancel</v-btn>
            </v-card-actions>
        </v-card>
    </v-overlay>

    <!-- Confirm Delete -->
    <v-overlay v-model="overlayDelete" class="align-center justify-center">
        <v-card class="lg" :width="300">
            <v-card-title>Confirm Delete ID {{ userData.id }}</v-card-title>
            <v-card-actions class="justify-end">
                <v-btn @click.stop="deleteUser(userData.id)">Confirm</v-btn>
                <v-btn @click="overlayDelete = !overlayDelete">Cancel</v-btn>
            </v-card-actions>
        </v-card>
    </v-overlay>

    <!-- OverlayEdit เพื่อแก้ไขข้อมูลที่เลือก -->
    <v-overlay v-model="overlayEdit" class="align-center justify-center">
        <v-card class="lg" width="300">
            <v-card-title>
                Edit
            </v-card-title>
            <v-card-text>
                <v-text-field v-model="fnameEdit" label="First Name"></v-text-field>
                <v-text-field v-model="lnameEdit" label="Last Name"></v-text-field>
                <v-text-field v-model="usernameEdit" label="Username"></v-text-field>
                <v-text-field v-model="emailEdit" label="E-mail"></v-text-field>
                <v-text-field v-model="avatarEdit" label="Avatar"></v-text-field>
            </v-card-text>
            <v-card-actions class="justify-end">
                <v-btn @click="editUser">Confirm</v-btn>
                <v-btn @click="overlayEdit = !overlayEdit">Cancel</v-btn>
            </v-card-actions>
        </v-card>
    </v-overlay>

    <!-- ตารางแสดงข้อมูลในฐานข้อมูล -->
    <v-table class="lg" fixed-header height="600px" density="compact">
        <thead>
            <tr>
                <th class="text-left"> ID </th>
                <th class="text-left"> First Name </th>
                <th class="text-left"> Last Name </th>
                <th class="text-left"> Username </th>
                <th class="text-left">Avatar </th>
                <th> <v-btn @click="overlayInsert = !overlayInsert">Insert</v-btn> </th>
            </tr>
        </thead>
        <tbody>
            <tr class="lg" v-for="userData in apiUser" :key="userData.id" @click="overlay = !overlay, tempData = userData">
                <td>{{ userData.id }}</td>
                <td>{{ userData.fname }}</td>
                <td>{{ userData.lname }}</td>
                <td>{{ userData.username }}</td>
                <td><v-img :width="50" aspect-ratio="1/1" cover :src=userData.avatar></v-img></td>
                <td>
                    <!-- ดึงข้อมูลไปไว้ใน Overlay Edit -->
                    <v-btn @click.stop="editFetch(userData.id)">Edit</v-btn>
                    <!-- ส่ง user ID ไปเพื่อลบข้อมูลในตารางที่ ID = userData.id -->
                    <v-btn @click.stop="deleteUser(userData.id)">Delete</v-btn>
                </td>
            </tr>
        </tbody>
    </v-table>

    <!-- Footer -->
    <v-footer>
        <div class="justify-left">พิพัฒน์ ทองดอนง้าว - จุ้ย - Frontend</div>
        <!-- <div class="justify-right"><v-pagination :length="4" v-model="currentPage"></v-pagination></div> -->
    </v-footer>
</template>

<script>
definePageMeta({
    middleware: "pipad-auth"
})
const config = useRuntimeConfig();
const URL_Auth = config.public.URL_Auth;
export default {
    data() {
        return {
            headers: [
                { text: 'ID', value: 'id' },
                { text: 'First Name', value: 'fname' },
                { text: 'Last Name', value: 'lname' },
                { text: 'Username', value: 'username' },
                { text: 'Avatar', value: 'avatar' },
                { text: '', value: 'actions', sortable: false },
            ],
            formRules: false,
            apiUser: [],
            overlay: false,
            overlayInsert: false,
            overlayEdit: false,
            overlayDelete: false,
            tempData: '',
            fname: '',
            avatar: '',
            lname: '',
            username: '',
            password: '',
            email: '',
            // ตัวแปรสำหรับการแก้ไขค่าข้อมูล
            idEdit: '',
            fnameEdit: '',
            lnameEdit: '',
            usernameEdit: '',
            avatarEdit: '',
            emailEdit: '',
            passwordRules: [
                value => {
                    if (value?.length >= 6) return true
                    return 'Password must be at least 6 characters.'
                },
            ],
            emailRules: [
                value => {
                    if (/^[^\s@]+@[^\s@]+\.[^\s@]+$/.test(value)) return true
                    return 'Email pattern not valid.'
                },
            ],

        };
    },
    methods: {
        async fetchUserapi() {
            try {
                console.log('Fetching URL:', `${URL_Auth}/api/users`);
                const response = await fetch(`${URL_Auth}/api/users`);
                const data = await response.json();
                this.apiUser = data;
                console.info("Information", this.apiUser);
            } catch (error) {
                console.error('Error fetching data', error);
            }
        },
        // methods ในการลบข้อมูล
        async deleteUser(id) {
            if (confirm("Confirm Delete ID : " + id)) {
                try {
                    const response = await fetch(`${URL_Auth}/api/users/delete`, {
                        method: 'DELETE',
                        headers: {
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            "id": id
                        }),
                    });
                    const result = await response.json();

                    if (result.status === "ok") {
                        alert(result.message);
                        console.log("deleting user:", result.message);
                        this.fetchUserapi()
                    }
                } catch (error) {
                    console.error("Error deleting user:", id, error);
                }
            }
        },
        // methods ในการเพิ่ม
        async editFetch(id) {
            try {
                await fetch(`${URL_Auth}/api/users/` + id) //fetch ข้อมูลจาก Api
                    .then((response) => response.json())
                    .then((data) => { //เอาข้อมูลลง data
                        console.log(data)
                        this.idEdit = data.user.id;
                        this.fnameEdit = data.user.fname;
                        this.lnameEdit = data.user.lname;
                        this.usernameEdit = data.user.username;
                        this.avatarEdit = data.user.avatar;
                        this.emailEdit = data.user.email;
                        console.log(this.fnameEdit, this.lnameEdit, this.usernameEdit, this.avatarEdit, this.emailEdit) //เอาข้อมูล data มาลง array apiUser
                        this.overlayEdit = !this.overlayEdit
                        this.fetchUserapi()
                    });

            } catch (error) {
                console.log(error)
            }
        },
        // methods ในการแก้ไขข้อมูล
        async editUser() {
            if (confirm("Confirm Edit")) {
                console.log("editUser called")
                try {
                    console.log("try entered")
                    const response = await fetch(`${URL_Auth}/api/users/update`, {
                        method: 'PUT',
                        headers: {
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            "id": this.idEdit,
                            "fname": this.fnameEdit,
                            "lname": this.lnameEdit,
                            "username": this.usernameEdit,
                            "email": this.emailEdit,
                            "avatar": this.avatarEdit,
                        }),
                    });
                    const result = await response.json();
                    if (result.status === 'ok') {
                        alert(result.message);
                        console.log(result.message)
                        // ล้างค่าในตัวแปร
                        this.fnameEdit = '';
                        this.lnameEdit = '';
                        this.usernameEdit = '';
                        this.emailEdit = '';
                        this.avatarEdit = '';
                        // ปิดหน้าต่าง
                        this.overlayEdit = !this.overlayEdit;
                        this.fetchUserapi()
                    }
                } catch (error) {
                    console.log(error)
                }
            }
        },
        // methods ในการเพิ่มข้อมูล
        async addUser() {
            const newUsercreate = {
                fname: this.fname,
                lname: this.lname,
                username: this.username,
                password: this.password,
                email: this.email,
                avatar: this.avatar,
            };
            try {
                const response = await fetch(`${URL_Auth}/api/users/create`, {
                    method: 'POST',
                    headers: {
                        'Content-Type': 'application/json',
                    },
                    body: JSON.stringify(newUsercreate),
                });
                const result = await response.json();
                if (result.status === 'ok') {
                    alert(result.message);
                    console.log(result.message)
                    // ล้างค่าในตัวแปร
                    this.fname = '';
                    this.lname = '';
                    this.username = '';
                    this.password = '';
                    this.email = '';
                    this.avatar = '';
                    // ปิดหน้าต่าง OverlayInsert
                    this.overlayInsert = !this.overlayInsert;
                    this.fetchUserapi()
                }
            } catch (error) {
                console.log(error)
            }
        }
    },
    mounted() {
        this.fetchUserapi(); //เรียกใช้ fetchUserapi เมื่อเปิดหน้า
        console.log("MEE BASE : " + URL_Auth)
    },
}
</script>